package jst.symtab;
import java.util.*;

import jst.app.JSTMessage;
import jst.parsetree.*;
import jst.symtab.link.*;

public abstract class ExecutableCode extends Decl {

	protected Set<Link> references;

    protected int numAnonymousNames;

	protected ExecutableCode(Decl theOwner, String theSimpleName, JstParseTreeBranch theSource) {
        super(theOwner, theSimpleName, theSource);
    }

    protected ExecutableCode(Decl newOwner, ExecutableCode that, Map<TypeParameter, ActualType> swaps) {
		super(newOwner, that, swaps);

		// Defer copying references to subclasses.
	}

	protected void init() {
		super.init();

		/*
        variablesUsed = new HashSet<VariableLookup>();
        methodInvocations = new HashSet<MethodLookup>();
        constructorInvocations = new HashSet<ConstructorLookup>();
		*/
		references = new HashSet<Link>();
	}

	/*
    public Set<VariableLookup> getVariablesUsed() {
        return variablesUsed;
    }

    public Set<MethodLookup> getMethodInvocations() {
        return methodInvocations;
    }

    public Set<ConstructorLookup> getConstructorInvocations() {
        return constructorInvocations;
    }
	*/

	public void addReference(Link link) {
		references.add(link);
    }
	
	public Set<Link> getReferences() {
		return references;
	}

	public boolean resolveReferences(List<JSTMessage> messages) {

		boolean ok = true;

    	for(Link link : references){

    		if(link.getFullName().startsWith("AbductionApp")){
    			System.out.println("Didn't resolve " + link);
    		}

			if (!link.resolve()) {
				ok = false;
				messages.add(link.getMessage());
	    		
			}
			/*
			else
				link.getDecl().addImplementedBy(this);
			*/
		}

		return ok;
	}

    // Generate artificial name for anonymous decl in this scope.
	public String generateName() {
        return "@" + String.valueOf(++numAnonymousNames);
    }
	
	/*
	public void addVariableUsage(JstParseTreeBranch expression) {
		variablesUsed.add(new VariableLookup(getScope(), expression));
    }
	
	public void addMethodInvocation(JstParseTreeBranch expression, JstParseTreeBranch argList) {
		methodInvocations.add(new MethodLookup(getScope(), expression, argList));
    }
	
	public void addConstructorInvocation(JstParseTreeBranch expression, JstParseTreeBranch argList) {
		constructorInvocations.add(new ConstructorLookup(getScope(), expression, argList));
    }
	
	public void addConstructorInvocation(String name, JstParseTreeBranch argList) {
		constructorInvocations.add(new ConstructorLookup(getScope(), name, argList));
    }
	
	protected abstract Scope getScope();
	*/
}
