
package jst.symtab;

import java.util.*;
import java.io.*;
import jst.parsetree.*;

public abstract class TypeDecl extends Decl {

    /**
     * @supplierCardinality 0..1
     * @supplierRole arrayOfType
     * @link aggregation*/
	protected ArrayType arrayOfType;

    /**
     * @supplierCardinality 0..1
     * @supplierRole typedDecls
     */
	protected Set<TypedDecl> typedDecls;
	
	protected TypeDecl(Decl theOwner, String theSimpleName, JstParseTreeBranch theSource) {
    	super(theOwner, theSimpleName, theSource);
	}

	protected TypeDecl(Decl newOwner, TypeDecl that, Map<TypeParameter, ActualType> swaps) {
		super(newOwner, that, swaps);
	}

	protected void init() {
		typedDecls = new HashSet<TypedDecl>();
	}

	public abstract void copy(UserType newOwnerUserType, Map<TypeParameter, ActualType> swaps);

    public boolean hasArrayType() {
        return arrayOfType != null;
    }

	public ArrayType getArrayType() {
    	if (arrayOfType == null)
        	arrayOfType = new ArrayType(this);

		return arrayOfType;
    }

	public ReferenceType asReferenceType() {
		return null;
	}

	public UserType asUserType() {
		return null;
	}

	public void addTypedDecl(TypedDecl decl) {
		typedDecls.add(decl);
	}

	public abstract boolean assignableFrom(TypeDecl rhs);
}
