
package jst.symtab;

import java.util.*;
import jst.parsetree.*;
import jst.symtab.link.*;
import jst.symtab.visitor.*;

public class TypeParameter extends ReferenceType {

	protected IntersectionType upperBound;

	public TypeParameter(GenericClassType ownerGenericClass, String theSimpleName, JstParseTreeBranch theSource) {
    	super(ownerGenericClass, theSimpleName, theSource);

		ownerGenericClass.addTypeParameter(this);
    }

	public TypeParameter(GenericInterfaceType ownerGenericInterface, String theSimpleName, JstParseTreeBranch theSource) {
    	super(ownerGenericInterface, theSimpleName, theSource);

		ownerGenericInterface.addTypeParameter(this);
    }
	
	/*
	public TypeParameter(GenericMethodDecl ownerGenericMethod, String theSimpleName, JstParseTreeBranch theSource) {
    	super(ownerGenericMethod, theSimpleName, theSource);

		ownerGenericMethod.addTypeParameter(this);
    }
	
	public TypeParameter(GenericConstructorDecl ownerGenericConstructor, String theSimpleName, JstParseTreeBranch theSource) {
    	super(ownerGenericConstructor, theSimpleName, theSource);

		ownerGenericConstructor.addTypeParameter(this);
    }
	*/

	public TypeParameter(GenericClassType newOwnerGenericClass, TypeParameter that, Map<TypeParameter, ActualType> swaps) {
		super(newOwnerGenericClass, that, swaps);

		newOwnerGenericClass.addTypeParameter(this);
	}

	/*
	public TypeParameter(GenericMethodDecl newOwnerGenericMethod, TypeParameter that, Map<TypeParameter, ActualType> swaps) {
		super(newOwnerGenericMethod, that, swaps);

		newOwnerGenericMethod.addTypeParameter(this);
	}

	public TypeParameter(GenericConstructorDecl newOwnerGenericConstructor, TypeParameter that, Map<TypeParameter, ActualType> swaps) {
		super(newOwnerGenericConstructor, that, swaps);

		newOwnerGenericConstructor.addTypeParameter(this);
	}
	*/

	protected void init() {
		super.init();

		new IntersectionType(this, source);
	}

	public void copy(UserType newOwnerUserType, Map<TypeParameter, ActualType> swaps) {
		assert false;
	}

	public void copy(GenericClassType newOwnerGenericClass, Map<TypeParameter, ActualType> swaps) {
		new TypeParameter(newOwnerGenericClass, this, swaps);
	}

	/*
	public void copy(GenericMethodDecl newOwnerGenericMethod, Map<TypeParameter, ActualType> swaps) {
		new TypeParameter(newOwnerGenericMethod, this, swaps);
	}

	public void copy(GenericConstructorDecl newOwnerGenericConstructor, Map<TypeParameter, ActualType> swaps) {
		new TypeParameter(newOwnerGenericConstructor, this, swaps);
	}
	*/

 	public String getCanonicalName() {
       	return "TYP_" + getOwnerScope().getCanonicalName().substring(4) + "." + simpleName;
    }

	public void setBound(IntersectionType theBound) {
    	upperBound = theBound;
    }

	public void addBound(TypeLookup type) {
    	upperBound.addBound(type);
    }

	public IntersectionType getUpperBound() {
		return upperBound;
	}

	public void addMethod(MethodDecl method) {
		assert false;
	}

	public void addField(FieldDecl field) {
		assert false;
	}

	public boolean isSubtypeOf(ReferenceType parent) {
		return upperBound.isSubtypeOf(parent);
	}

	public boolean assignableFrom(TypeDecl rhs) {
		if (rhs instanceof NullType)
        	return true;

		if (rhs == this)
        	return true;

		return false;
    }

	public String generateName() {
		assert false;
		return null;
	}

	public VariableDecl lookupVariable(boolean widen, String variableName, ReferenceType looker) {
		assert !widen;

		return upperBound.lookupVariable(false, variableName, looker);
	}

	public TypeDecl lookupType(boolean widen, String typeName, ReferenceType looker) {
		assert !widen;

		return upperBound.lookupType(false, typeName, looker);
	}

	public MethodDecl lookupMethod(boolean widen, String methodName, List params, ReferenceType looker) {
		assert !widen;

		return upperBound.lookupMethod(false, methodName, params, looker);
	}
	
    public void accept(ModelVisitor visitor) {
        visitor.visitTypeParameter(this);
    }
}
