
package jst.symtab;

import java.util.*;

import jst.app.JSTMessage;
import jst.parsetree.*;
import jst.symtab.link.*;

public abstract class TypedDecl extends Decl {
	
    /**
     * @supplierCardinality 1
     * @supplierRole typeRef
     */
	protected TypeLink typeRef;

	protected TypedDecl(Decl theOwner, String theSimpleName, JstParseTreeBranch theSource) {
    	super(theOwner, theSimpleName, theSource);
    }
	
	protected TypedDecl(Decl newOwner, TypedDecl that, Map<TypeParameter, ActualType> swaps) {
    	super(newOwner, that, swaps);

		typeRef = that.typeRef.copyType(this);
    }

	public void setTypeRef(TypeLink type) {
    	typeRef = type;
	}

	public boolean resolveType(List messages) {
		
		if (!typeRef.resolve()) {
			messages.add(typeRef.getMessage());
			return false;
		}

		if (typeRef.getType() != null)
			typeRef.getType().addTypedDecl(this);

		return true;
    }

	public TypeDecl getType() {
    	return typeRef.getType();
    }
}
