package jst.symtab.visitor;

import java.util.*;

import jst.app.JSTMessage;
import jst.symtab.*;
import jst.parsetree.*;

public class MemberTypeResolver extends CompositionVisitor {

    protected List<JSTMessage> messages;

    public MemberTypeResolver() {
        messages = new ArrayList<JSTMessage>();
    }

    public void visitPackageDecl(PackageDecl packageDecl) {
		// Omit SourceFiles.
        visitKids(packageDecl.getTypes());
        visitKids(packageDecl.getSubPackages());
    }

    public void visitTypedDecl(TypedDecl typedDecl) {
		typedDecl.resolveType(messages);

        super.visitTypedDecl(typedDecl);
    }

	/*
    public void visitLocalVariableDecl(LocalVariableDecl localVariableDecl) {
		// Do these later.
	}
	*/

	public List getMessages() {
		return messages;
	}
}
