package jst.symtab.visitor;
import jst.symtab.*;

public interface ModelVisitor {

    public void visitDecl(Decl decl);
    public void visitPackageDecl(PackageDecl packageDecl);
    public void visitSourceFile(SourceFile sourceFile);
    public void visitTypeDecl(TypeDecl typeDecl);
    public void visitPrimitiveType(PrimitiveType primitiveType);
    public void visitNullType(NullType nullType);
    public void visitActualType(ActualType actualType);
    public void visitReferenceType(ReferenceType referenceType);
    public void visitArrayType(ArrayType arrayType);
    public void visitUserType(UserType userType);
    public void visitInterfaceType(InterfaceType interfaceType);
    public void visitGenericInterfaceType(GenericInterfaceType genericInterfaceType);
    public void visitParameterizedInterfaceType(ParameterizedInterfaceType parameterizedInterfaceType);
    public void visitClassType(ClassType classType);
    public void visitGenericClassType(GenericClassType genericClassType);
    public void visitParameterizedClassType(ParameterizedClassType parameterizedClassType);
    public void visitTypedDecl(TypedDecl typedDecl);
    public void visitVariableDecl(VariableDecl variableDecl);
    public void visitFieldDecl(FieldDecl fieldDecl);
    public void visitLocalVariableDecl(LocalVariableDecl localVariableDecl);
    public void visitParameterDecl(ParameterDecl parameterDecl);
    public void visitOperationDecl(OperationDecl operationDecl);
    public void visitMethodDecl(MethodDecl methodDecl);
    public void visitConstructorDecl(ConstructorDecl constructorDecl);
    public void visitExecutableCode(ExecutableCode executableCode);
    public void visitBlock(Block Block);
    public void visitCatchBlock(CatchBlock catchBlock);
    public void visitFieldInitializer(FieldInitializer fieldInitializer);
    public void visitWildcardType(WildcardType wildcardType);
    public void visitTypeParameter(TypeParameter typeParameter);

}
