package parser.pda;
import parser.pda.stateMachine.State;
import parser.parsetree.*;
import parser.grammar.Production;
import java.util.*;
import parser.pda.tokenStream.Looker;

public class GotoNode extends GSSNode {

    /**
     * @supplierRole previous
     * @supplierCardinality 0..1 
     */
    protected GSSNode previous;

    protected SyntaxTree tree;

    public GotoNode(NondeterministicParser theParser, GSSNode prev, State theState, SyntaxTree theTree) {
        super(theParser, theState);
        parser = theParser;
        previous = prev;
        tree = theTree;
    }

    protected void reducePrevious(int n, Production prod, List kids, Looker input) {
        kids.add(0, tree);
        previous.reduce(n, prod, kids, input);
        kids.remove(0);
	}

    public GSSNode checkCycle(State dst) {
        if (state == dst)
            return this;

        if (tree.asBranch().getKids().length == 0)
            return previous.checkCycle(dst);

        return null;
    }

    public SyntaxTree getTree(GSSNode prev) {
        return prev == previous? tree : null;
    }

    public SyntaxTreeBranch getResult() {
        return tree.asBranch();
    }
}
