package parser.pda.stateMachine;
import parser.grammar.Production;
import parser.grammar.Symbol;
import java.util.*;

public class DeterministicStateTable extends StateTable {

    protected int[][] actions;

	protected Production[] reductions;

    protected DeterministicStateTable(int theStartState, int theStopState) {
        super(theStartState, theStopState);
    }

    public int getTransition(int state, Symbol symbol) {
        int dst = actions[state][symbol.getID()];

        return dst > 0? dst : 0;
    }

    public Production getReduction(int state, Symbol symbol) {
        int reduce = actions[state][symbol.getID()];

        return reduce < 0? reductions[-reduce] : null;
    }

    public Set getExpected(int state) {
        Set result = super.getExpected(state);

        for(int i = 1; i < symbols.length; i++) {
            Symbol symbolType = symbols[i];

            if (symbolType.isTerminal() && getReduction(state, symbolType)!= null )
	                result.add(symbolType.toString());
	    }

        return result;
    }
}
